LDAP Exporter - Release Notes

  • Bug Fixes
  • Feature Improvements
  • Contact

Bug Fixes

  • Truncated Text: In some situations the attribute values were being truncated if reached a length greater than 255 characters. The limitation has been increased to 1024 chracters which is more than sufficent for most environments.
  • Delimiter Added: In a situations where an attribute contains multiple values, a sperator delimiter has been added to identify the values.
  • SSL/TLS Handler: Previously the SSL/TLS handler had issues when connecting to LDAP servers such as OpenLDAP, this has now been fixed.

Feature Improvements

  • Improved performance: Some of the libraries have been updated such as the LDAP SSL handler ans caching system in order to improve memory management and performance.
  • Support for LDIF files: LDAP Exporter can noe export to LDIF files.

Contact

I hope that you all find this application benefitial to your use. Please forward all comments and feedback to me at: shaffin.bhanji@gmail.com.

You can also access information online at OpenSS or browse the Support Forums.

This application is copyright 2004 by Shaffin N. Bhanji. Please do not modify or change without a written concent.


LDAP Exporter - Overview

  • Overview
  • Introduction
  • Features
  • Software Requirements
  • Screen Shot
  • Contact

Overview

LDAP Exporter by Shaffin Bhanji is a software product unique to the requirement of generating data exports from an Lightweight Directory Access Protocol (LDAP) Server. LDAP Exporter has been specifically written for the Win32 platform and offers an Explorer-like interface which is easy to use. LDAP Exporter is ideal for individuals working with LDAP and who require flexibility to generate various definitions of data export files from a LDAP Server. Though the software is written to cater to LDAP v3 specifications, it has limited functionality to handle LDAP v2 servers. This help file explains the concepts and use of LDAP Exporter and does not indulge into explaining LDAP Servers. LDAP Exporter is distributed for FREE. You can Download it and try it, and let me know of any feedback or recommendations by email at shaffin_bhanji@hotmail.com.

Introduction

LDAP Exporter can be used to create multiple export profiles against a given LDAP Server. These export profiles can then be run to generate data within a grid. The data can then be optionaly exported to one of the following formats:

  • HTML
  • Microsoft Word
  • Microsoft Excel
  • Text
  • Rich Text
  • Comma Seperated Text
  • Tab Seperated Text
  • Data Interchange Format
  • SYLK Format

LDAP Exporter Features

Some of the features that LDAP Exporter currently supports are as follows:

  • Adding, changing and removing server profiles: A server profile contains setting's of a LDAP Server such as the LDAP Server's IP address and Port. You can have as many servers as possible within a workspace. To add a server to the workspace, please follow the the page titled "Servers".
  • Adding, changing and removing export profiles: An export profile consists of seetings defined to query objects from a LDAP Server such the objectClass and Filter. You can have as many export profiles as possible that belong to a specific server. To add an export profile to a server, please follow the page titled "Profiles".
  • Run a single export profile at any given time.
  • Export a profile to one of the available formats mentioned earlier on this page.
  • Ability to browse for objects in a LDAP Server.
  • Ability to request properties of an object in a LDAP Server.

Software Requirements

In order to successfully install and run LDAP Exporter, your system needs to have the following:

  • Windows 2000/XP/98
  • Updated Operating System Service Pack (http://windowsupdate.microsoft.com)

Screen Shot

This is a screen shot of LDAP Exporter to see what the user interface looks like.

Contact

I hope that you all find this application benefitial to your use. Please forward all comments and feedback to me at: shaffin.bhanji@gmail.com.


LDAP Exporter - Servers

  • Servers in LDAP Exporter
  • Adding a Server
  • Modifying a Server's information
  • Removing a Server
  • Testing a Server's Connection

Servers in LDAP Exporter

A Server in LDAP Exporter id an object that stores connection information of a LDAP Server. When making a connection, LDAP Exporter uses this information to establish a connection to LDAP. A Server object can have multiple Export Profiles for data export. The Server object supports the following properties while binding to an LDAP Server:

Server Properties | Description | Example
Name | A name of a Server object | Localhost
Host IP | An IP address or DNS name of the LDAP Server | 127.0.0.1
Port | A TCP/IP port to use when establishing a connect to the LDAP Server | 389
SSL | Establish a Secure Socket Layer (SSL) connection. Wjen establishing a SSL connection, all communication between LDAP Exporter and the LDAP Server is encrypted | Checked (Enable SSL)
User DN | The valid user's distinguished name (DN) to use when binding to the LDAP Server | CN=Admin, OU=Users, O=Organization
Password | The password to use when establishing a connection | ********

Adding a Server

In order to add a Server to LDAP Exporter follow the instructions underlined below:

  • In the workspace tree, select the "Workspace" by clicking on it with the left mouse
  • You will notice that the "Add Server" menu item is now available to you or you can right click the mouse button and you should see a popup menu "New Server". Use either of these methods to add a new server object to LDAP Exporter.
  • The New Server dialog box should now be visible. Provide the Name, Host IP, Port, User DN and Password of a valid LDAP Server. Please note that all the information is mandatory.
  • You can now save the new server object or chose to test the connection to the LDAP Server.
  • You should now see the new server object in the Workspace tree.

A screen of the New Server dialog box is shown below.

Modifying Server Properties

To modify a Server's information, follow the steps defined below:

  • In the workspace tree, select the server in question by clicking on it with the left mouse button
  • Right click your mouse when over the Server, you will notice that a popup menu "Edit Server" is now available
  • Click on "Edit Server"
  • You should now see a dialog "Server Properties: [Server Name]"
  • Modify the appropriate Server's information and click on the "Save" button

Removing a Server

In order to remove a Server from LDAP Exporter, follow the instructions underlined below:

  • In the workspace tree, select the Server in question by clicking on it with the left mouse button
  • Right click your mouse when over the Server, you will notice that a popup menu "Delete Server" is now available
  • Click on "Delete Server"
  • You will be propted for confirmation of the delete, upon confirming, the Server will now be deleted. Note that any Export Profiles that belong to the Server will be deleted also

Testing a Server's Connection

In order to test a Server's connection to the LDAP Server, follow the instructions below:

  • In the workspace tree, select the Server in question by clicking on it with the left mouse button
  • You will now see a Toolbar Button "Test Connection" available
  • Use this button and the connection to the LDAP Server will be verified. You will be notified the results of the connection

Contact

I hope that you all find this application benefitial to your use. Please forward all comments and feedback to me at: shaffin.bhanji@gmail.com.


LDAP Exporter - Export Profiles

  • Export Profiles in LDAP Exporter
  • Adding an Export Profile
  • Modifying an Export Profile
  • Removing an Export Profile
  • Running an Export Profile
  • Saving an Export Profile

Export Profiles in LDAP Exporter

An Export Profile in LDAP Exporter defines the search criteria to be used when requesting data from an LDAP Server. AN Export Profile is very specific to a Server object it belongs to as it utlilizes the Server object's connection to establish a connection to the LDAP Server. A Server can have more than one Export Profiles that can be saved and used at liberty. An example may be that you have two esport profiles for a Server, one for exporting Users and the other to export Groups. An Export Profile object supports the following attributes:

Export Profile Attributes | Description | Example
Name | The name to be given to this export profile | Users
Base DN | The base distinguished name (DN) of an object (in most cases a container) to be used for the search. | OU=Users, O=Organization
Scope The scope of the search. Valid values are:
  • Base Object: Only search the object (Base DN)
  • Single Container: Only search for objects within the container
  • Sub Container: Search for objects in all containers
Filter | A filter to be used to limit the type of objects to be searched for in the LDAP Server | (objectClass=User)
Attribute List | A semi-colon seperated list of all the attributes required from the objects that match the search in the LDAP Server | cn;surname

Adding an Export Profile

In order to add an Export Profile to LDAP Exporter, follow the instructions below:

  • In the workspace tree, select the Server node under which the new Export Profile is needed by clicking on it with the left mouse button
  • You will notice that the "Add Profile" menu item is now available or alternatively you can right click the mouse button and you will see a popup menu "New Profile". Click on the "Add Profile" menu item
  • A dialog box should be visible with a title "Profile Properties". Provide the Name, Base DN, Scope, Filter and Attribute List of the Export Profile
  • Click on the Save button in the dialog box and you should now see the new Export Profile created under the Server node within the respective Server

A screen of the New Profile dialog box is shown below.

Modifying an Export Profile

To modify an Export Profile, follow the steps defined below:

  • In the workspace tree, select the Profile in question by clicking on it with the left mouse button
  • Right click your mouse when over the Profile in question, you will notice that a popup menu "Edit Profile" is now available
  • Click on "Edit Profile"
  • You should now see a dialog "Profile Properties"
  • Modify the appropriate Profile information and click on the "Save" button

Removing an Export Profile

In order to remove an Export Profile from LDAP Exporter, follow the instructions underlined below:

  • In the workspace tree, select the Profile in question by clicking on it with the left mouse button
  • Right click your mouse when over the Profile in question, you will notice that a popup menu "Delete Profile" is now available
  • Click on "Delete Profile"
  • You should now see that the Profile no longer exists under the respective Server in the workspace

Running an Export Profile

In order to run an Export Profile follow the instructions below:

  • In the workspace tree, select the Profile in question by clicking on it with the left mouse button
  • Right click your mouse when over the Profile in question, you will notice that a popup menu "Run Profile" is now available
  • Click on "Run Profile"
  • The profile should start running and you can see the progress on the statusbar. When complete the grid should show the results of the Export Profile

Saving the results of an Export Profile

You can only save the results of an Export Profile when you have information displayed in the grid. In order to save the results of an Export Profile follow the instructions below:

  • On the toolbar you should see a tool button available "Save Report". Click on Save Report and follow the screen instruction to save the rsults in the chosen format. LDAP Exporter supports various file formats that results can be saved in.
  • You will be prompted to choose the format:

    and then the filename you would like to save the results in:

Contact

I hope that you all find this application benefitial to your use. Please forward all comments and feedback to me at: shaffin.bhanji@gmail.com.

You can also access information online at OpenSS or browse the Support Forums.

This application is copyright 2002 by Shaffin N. Bhanji. Please do not modify or change without a written concent.


LDAP Exporter - Object Browser

  • Browse for Objects
  • View Object's Properties
  • Export Object's Properties

Browse for Objects

LDAP Exporter allows the ability to browse for objects that reside in a LDAP Server. To browse for objects in a LDAP Server you must already have a server defined. If you do not have a server defined, please follow the instructions Add a New Server. When browsing, LDAP Exporter uses the servers BaseDN as the primary container for its query. LDAP Exporter supports container level browsing, which means that you must initiate a 'browse' for each container you would objects for. To browse for objects, please follow the following instructions:

  • Beside the workspace tree, select "Browser" by clicking on it
  • Select the server you would like to browse objects for
  • Right click the mouse button when over the server in question
  • Select the Browse menu item
  • You should now see the objects being populated, if not, then no objects exist in the selected server/container

Note that you need to repeat the above for every container that you would like to browse objects for.

View Object Properties

LDAP Exporter allows the ability to view properties of a specific object. To view the properties of an object, please follow the following instructions:

  • Select the object in the browser
  • Right click the mouse button when over the object in question
  • Select the Properties menu item
  • You should now see the objects properties being requested and populated n the grid

Export Object Properties

When the grid has been populated with an object's properties, you may export the contents of the grid to a file by clicking on the "Save Report" toolbar button. To find out more about exporting to a file, please go to .

Contact

I hope that you all find this application benefitial to your use. Please forward all comments and feedback to me at: shaffin.bhanji@gmail.com.


LDAP Exporter - FAQ

LDAP Exporter - Frequently Asked Questions

  1. Why is my search limited to a certain number of entries, is there any such limitation in LDAP Exporter to limit the search results?
  2. I just downloaded LDAP Exporter 1.2, is it backwards compatible to the previous version?
  3. Can LDAP Exporter export to LDIF files?
  4. Where can access support resources for LDAP Exporter?

Why is my search limited to a certain number of entries, is there any such limitation in LDAP Exporter to limit the search results?

LDAP Exporter does not impose such limitations but your LDAP Server may. In order to optimize the server's search capabilities some LDAP Servers by default have a search limit (number of entries retured). A good example is Active Directory which by default limits a search result to 5000 entries.

I just downloaded LDAP Exporter 1.2, is it backwards compatible to the previous version?

No, version 1.2 is not backwards compatible due to the re-write of the some libraries. You will need to manually add servers and search profiles again. I appologize for this constraint but as much as I wanted to, I could not preserve some of the internal memory structures as they required change.

Can LDAP Exporter export to LDIF files?

Yes, as of version 1.2 this feature has been added.

Where can access support resources for LDAP Exporter?

There is a support forum that has been setup online at OpenSS Forums.

Contact

I hope that you all find this application benefitial to your use. Please forward all comments and feedback to me at: shaffin.bhanji@gmail.com.


LDAP Exporter - License Agreement

  • Important Notice
  • Scope of Use
  • Restrictions
  • No Additional Rights or Licenses
  • Term and Termination
  • Warranty and Remedies
  • Limitation on Liability
  • Miscellaneous

STANDARD LICENSE AGREEMENT

Copyright (C) 2001-2004 by Shaffin Bhanji.

This is an Agreement between, Shaffin Bhanji, owner of the LDAP Exporter software ("Software"), and you ("Licensee"), for the purpose of specifying the conditions under which Licensee will use the Software.

Important Notice

This Agreement is a legal contract which specifies the terms of the license and warranty limitation between you and Shaffin Bhanji for the LDAP Exporter software and related documentation. You should carefully read the following terms and conditions before installing or using the Software. Unless you have entered into a separate written license agreement with Shaffin Bhanji providing otherwise, installation or use of the Software indicates your agreement to be bound by these terms and conditions. If you do not agree to these terms, do not attempt to install or use the Software.

Scope of Use

  • You may install the Software on a hard disk or other storage device; install and use the Software on a file server for use on a network for the purposes of (i) permanent installation onto hard disks or other storage devices or (ii) use of the Software over such network; and make backup copies of the Software.
  • You may make and distribute unlimited copies of the Software, including copies for commercial distribution, as long as each copy that you make and distribute contains this Agreement and the same copyright and other proprietary notices pertaining to this Software that appear in the Software. If you download the Software from the Internet or similar on-line source, you must include the Shaffin Bhanji copyright notice for the Software with any on-line distribution and on any media you distribute that includes the Software.

Portions of the Software may not be used independently of the Software.

Restrictions

The Software is owned by Shaffin Bhanji and code are the valuable trade secrets of Shaffin Bhanji. You agree not to modify, adapt, translate, reverse engineer, decompile, disassemble or otherwise attempt to discover the source code of the Software.

No Additional Rights or Licenses

You acknowledge and agree that except for the rights granted in this Agreement, all other rights, and all title and interest in and to the Software (as an independent work and as an underlying work serving as a basis for any application you may develop) and related documentation remain the sole and exclusive property of Shaffin Bhanji, and that you will not derive or assert any title or interest in or to the Software or related documentation. Without limiting the generality of the foregoing, you do not receive any rights to any patents, copyrights, trademarks rights to the Software or related documentation. This Agreement does not authorize you to use Shaffin Bhanji's name or any of its trademarks.

Term and Termination

The license granted for the LDAP Exporter Software will continue until it is terminated. Shaffin Bhanji may terminate any license granted herein if you fail to comply with the terms of this Agreement. Upon the termination of a license for any reason, you must promptly return to Shaffin Bhanji or destroy all copies of the Software and related documentation covered by the license.

Warranty and Remedies

SHAFFIN BHANJI PROVIDES NO REMEDIES OR WARRANTIES, WHETHER EXPRESS OR IMPLIED, FOR THE SOFTWARE. THE SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS."

THESE REMEDIES ARE THE SOLE AND EXCLUSIVE REMEDIES AVAILABLE TO YOU FOR BREACH OF EXPRESS OR IMPLIED WARRANTIES WITH RESPECT TO THE SOFTWARE AND RELATED DOCUMENTATION.

THE FOREGOING WARRANTIES ARE IN LIEU OF ALL OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY WARRANTY OF NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. By way of example, without limitation, Shaffin Bhanji provides no warranties of any kind to any end-users accessing or otherwise using applications developed or otherwise obtained by you.

The warranties do not cover damage or defects caused by or related to misuse, accident, negligence or misapplication. Because programs such as this are inherently complex, Shaffin Bhanji does not warrant that the Software is error-free or will operate without interruption. Furthermore, Shaffin Bhanji does not warrant that the Software will work with any given database, network or network application.

You acknowledge that due to the complexity of the Software, it is possible that use of the Software could lead to the unintentional loss or corruption of data. You assume all risks of such data loss or corruption; the warranties provided in this Agreement do not cover any damages or losses resulting from data loss or corruption.

Limitation on Liability

IN NO CASE SHALL SHAFFIN BHANJI BE LIABLE FOR ANY INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES OR LOSS, INCLUDING, WITHOUT LIMITATION, LOST PROFITS OR THE INABILITY TO USE EQUIPMENT OR ACCESS DATA, WHETHER SUCH DAMAGES ARE BASED UPON A BREACH OF EXPRESS OR IMPLIED WARRANTIES, BREACH OF CONTRACT, NEGLIGENCE, STRICT TORT, OR ANY OTHER LEGAL THEORY. THIS IS TRUE EVEN IF SHAFFIN BHANJI IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

Miscellaneous

This Agreement is the complete agreement between you and Shaffin Bhanji concerning the Software and related documentation. The failure or delay of Shaffin Bhanji to exercise any of its rights under this Agreement or upon any breach of this Agreement shall not be deemed a waiver of those rights or of the breach.

Contact

I hope that you all find this application benefitial to your use. Please forward all comments and feedback to me at: shaffin.bhanji@gmail.com.